/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-05 16:09:48 UTC)
 * on 2013-06-11 at 10:55:07 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.bigquery.model;

/**
 * Model definition for DatasetList.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the BigQuery API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class DatasetList extends com.google.api.client.json.GenericJson {

  /**
   * An array of one or more summarized dataset resources. Absent when there are no datasets in the
   * specified project.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Datasets> datasets;

  static {
    // hack to force ProGuard to consider Datasets used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Datasets.class);
  }

  /**
   * A hash of this page of results. See Paging Through Results in the developer's guide.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String etag;

  /**
   * The type of list.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * A token to request the next page of results. Present only when there is more than one page of
   * results.* See Paging Through Results in the developer's guide.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String nextPageToken;

  /**
   * An array of one or more summarized dataset resources. Absent when there are no datasets in the
   * specified project.
   * @return value or {@code null} for none
   */
  public java.util.List<Datasets> getDatasets() {
    return datasets;
  }

  /**
   * An array of one or more summarized dataset resources. Absent when there are no datasets in the
   * specified project.
   * @param datasets datasets or {@code null} for none
   */
  public DatasetList setDatasets(java.util.List<Datasets> datasets) {
    this.datasets = datasets;
    return this;
  }

  /**
   * A hash of this page of results. See Paging Through Results in the developer's guide.
   * @return value or {@code null} for none
   */
  public java.lang.String getEtag() {
    return etag;
  }

  /**
   * A hash of this page of results. See Paging Through Results in the developer's guide.
   * @param etag etag or {@code null} for none
   */
  public DatasetList setEtag(java.lang.String etag) {
    this.etag = etag;
    return this;
  }

  /**
   * The type of list.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The type of list.
   * @param kind kind or {@code null} for none
   */
  public DatasetList setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * A token to request the next page of results. Present only when there is more than one page of
   * results.* See Paging Through Results in the developer's guide.
   * @return value or {@code null} for none
   */
  public java.lang.String getNextPageToken() {
    return nextPageToken;
  }

  /**
   * A token to request the next page of results. Present only when there is more than one page of
   * results.* See Paging Through Results in the developer's guide.
   * @param nextPageToken nextPageToken or {@code null} for none
   */
  public DatasetList setNextPageToken(java.lang.String nextPageToken) {
    this.nextPageToken = nextPageToken;
    return this;
  }

  @Override
  public DatasetList set(String fieldName, Object value) {
    return (DatasetList) super.set(fieldName, value);
  }

  @Override
  public DatasetList clone() {
    return (DatasetList) super.clone();
  }

  /**
   * Model definition for DatasetListDatasets.
   */
  public static final class Datasets extends com.google.api.client.json.GenericJson {

    /**
     * Reference identifying dataset.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private DatasetReference datasetReference;

    /**
     * A descriptive name for this dataset, if one exists.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String friendlyName;

    /**
     * The fully-qualified unique name of this dataset in the format projectId:datasetId.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String id;

    /**
     * The resource type.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String kind;

    /**
     * Reference identifying dataset.
     * @return value or {@code null} for none
     */
    public DatasetReference getDatasetReference() {
      return datasetReference;
    }

    /**
     * Reference identifying dataset.
     * @param datasetReference datasetReference or {@code null} for none
     */
    public Datasets setDatasetReference(DatasetReference datasetReference) {
      this.datasetReference = datasetReference;
      return this;
    }

    /**
     * A descriptive name for this dataset, if one exists.
     * @return value or {@code null} for none
     */
    public java.lang.String getFriendlyName() {
      return friendlyName;
    }

    /**
     * A descriptive name for this dataset, if one exists.
     * @param friendlyName friendlyName or {@code null} for none
     */
    public Datasets setFriendlyName(java.lang.String friendlyName) {
      this.friendlyName = friendlyName;
      return this;
    }

    /**
     * The fully-qualified unique name of this dataset in the format projectId:datasetId.
     * @return value or {@code null} for none
     */
    public java.lang.String getId() {
      return id;
    }

    /**
     * The fully-qualified unique name of this dataset in the format projectId:datasetId.
     * @param id id or {@code null} for none
     */
    public Datasets setId(java.lang.String id) {
      this.id = id;
      return this;
    }

    /**
     * The resource type.
     * @return value or {@code null} for none
     */
    public java.lang.String getKind() {
      return kind;
    }

    /**
     * The resource type.
     * @param kind kind or {@code null} for none
     */
    public Datasets setKind(java.lang.String kind) {
      this.kind = kind;
      return this;
    }

    @Override
    public Datasets set(String fieldName, Object value) {
      return (Datasets) super.set(fieldName, value);
    }

    @Override
    public Datasets clone() {
      return (Datasets) super.clone();
    }

  }

}
